
;;;----------------------------------------------------------------------
;;; Example 2a-2 (circ-membrane)
;;; membrane - hammer - strike
;;;----------------------------------------------------------------------

(new)
(multi)
(set-sample-rate 44100)

(defun midi2hz (x) (* 440 (expt 2 (/ (- x 69) 12))))

;;;----------------------------------------------------------------------
;;; objects
;;;----------------------------------------------------------------------

(defvar my-membrane)
(setq my-membrane 
               	(make-object 'circ-membrane
               	(modes 80)
				(radius 0.5)
              	(tension 1000)
               	(mass 0.01)
               	(freq-loss 0.4)
               	(const-loss 0.3)))

(set-pitch my-membrane 'tension (midi2hz 48)) 

(defvar my-hammer)
(setq my-hammer (make-object 'mono-two-mass))

;;;----------------------------------------------------------------------
;;; controllers
;;;----------------------------------------------------------------------

(defvar hammer-ctrl)
(setq hammer-ctrl (make-controller 'envelope 1 (list(list 0 0.1)
												(list 0.1 0)
												(list 0.15 0.1)
                                                (list 0.6 0.1))))

;;;----------------------------------------------------------------------
;;; access 
;;;----------------------------------------------------------------------

(defvar my-membrane-out1)
(setq my-membrane-out1 (make-access my-membrane (const 0.2 0.2) 'normal))
(defvar my-membrane-out2)
(setq my-membrane-out2 (make-access my-membrane (const 0.8 0.8) 'normal))

(setq my-membrane-hit (make-access my-membrane (const 0.2 0.3) 'normal))

(defvar my-hammer-tip)
(setq my-hammer-tip (make-access my-hammer (const 1) 'trans0))
(defvar my-hammer-top)
(setq my-hammer-top (make-access my-hammer (const 0) 'trans0))

;;;----------------------------------------------------------------------
;;; connections
;;;----------------------------------------------------------------------
                                       
(make-connection 'position my-hammer-top hammer-ctrl)

(make-connection 'strike my-hammer-tip .1 my-membrane-hit 0)

;;;----------------------------------------------------------------------
;;; listening point on plate
;;;----------------------------------------------------------------------

(make-point-output my-membrane-out1 0 (const 1))
(make-point-output my-membrane-out2 1 (const 1))

;;;----------------------------------------------------------------------
;;; run the synthesis and play the sound
;;;----------------------------------------------------------------------

(run 5)
(play)

