
;;;----------------------------------------------------------------------
;;; Example 4a
;;; tube - force
;;;----------------------------------------------------------------------

(new)
(multi)
(set-sample-rate 44100)

(defun midi2hz (x) (* 440 (expt 2 (/ (- x 69) 12))))

;;;----------------------------------------------------------------------
;;; objects
;;;----------------------------------------------------------------------

(defvar my-tube)
(setq my-tube (make-object 'closed-open-tube
               	(modes 160)
				(length 1)
				(air-elasticity 7.14e-06)               				(radius0 0.01)
               	(radius1 0.01)))

(set-pitch my-tube 'length (midi2hz 60))
                  
;;;----------------------------------------------------------------------
;;; controllers
;;;----------------------------------------------------------------------

(defvar my-controller)
(setq my-controller (make-controller 'envelope 1  
							(list 	(list 0 0)
									(list 0.01 -2)
									(list 0.2 0))))

;;;----------------------------------------------------------------------
;;; access 
;;;----------------------------------------------------------------------

(defvar my-tube-top)
(setq my-tube-top (make-access my-tube (const 0.) 'long))
(defvar my-tube-out)
(setq my-tube-out (make-access my-tube (const .90) 'long))

;;;----------------------------------------------------------------------
;;; connections
;;;----------------------------------------------------------------------

(defvar my-force-connection)
(setq my-force-connection (make-connection 'force my-tube-top my-controller))

;;;----------------------------------------------------------------------
;;; listening point on tube
;;;----------------------------------------------------------------------

(make-point-output my-tube-out)

;;;----------------------------------------------------------------------
;;; run the synthesis and play the sound
;;;----------------------------------------------------------------------

(run 4)
(play)
