
;;;----------------------------------------------------------------------
;;; Example 1a (rect-plate brass)
;;; plate - hammer - strike with plotting
;;;----------------------------------------------------------------------

(new)
(multi)
(set-sample-rate 44100)


;;;----------------------------------------------------------------------
;;; objects
;;;----------------------------------------------------------------------

(setq my-plate 
               (make-object 'rect-plate
               (thickness 0.2)
               (modes 160)
               (density 8500)
               (young 1.04e11)
               (freq-loss 0.4)
               (const-loss 0.3)))

(set-pitch my-plate 'size (make-controller 'dynamic 1 -1 (list 440) "freq")) 

(setq my-hammer (make-object 'mono-two-mass))

;;;----------------------------------------------------------------------
;;; controllers
;;;----------------------------------------------------------------------

(defvar hammer-ctrl)
(setq hammer-ctrl 
	(make-controller 'dynamic 1 -1 (list 0.1) "hammer-ctrl"))

;;;----------------------------------------------------------------------
;;; access 
;;;----------------------------------------------------------------------

(defvar my-plate-out1)
(setq my-plate-out1 (make-access my-plate (make-controller 'dynamic 2 -1 (list 0.2 0.2) "out1-ctrl") 'normal))

(defvar my-plate-out2)
(setq my-plate-out2 (make-access my-plate (make-controller 'dynamic 2 -1 (list 0.8 0.8) "out2-ctrl") 'normal))

(defvar my-plate-hit)
(setq my-plate-hit (make-access my-plate (make-controller 'dynamic 2 -1 
(list 0.5 0.5) "hit-ctrl") 'normal))

(setq my-hammer-tip (make-access my-hammer (const 1) 'trans0))
(setq my-hammer-top (make-access my-hammer (const 0) 'trans0))

;;;----------------------------------------------------------------------
;;; connections
;;;----------------------------------------------------------------------
                                       
(make-connection 'position my-hammer-top hammer-ctrl)

(make-connection 'strike my-plate-hit 0 my-hammer-tip .1)

;;;----------------------------------------------------------------------
;;; listening point on plate
;;;----------------------------------------------------------------------

(make-point-output my-plate-out1 0 (const 1))
(make-point-output my-plate-out2 1 (const 1))

;;;----------------------------------------------------------------------
;;; save real-time script
;;;----------------------------------------------------------------------

;(save-script "/Volumes/DataStor/_Vorlesungen_Seminare/physical_modeling/ex_max/01a-plate-hammer-strike.mlys")
